# Step by Step: Minting a token with a Plutus Script

## Step 1: Make sure that `/ppbl2023-plutus-template` is up to date
#### If you are working locally on Demeter.run, pull the latest changes to the [PPBL 2023 Plutus Template on GitLab](https://gitlab.com/gimbalabs/ppbl-2023/ppbl2023-plutus-template) (last updated 2023-04-21)

In `/ppbl2023-plutus-template`, run `git pull`
```bash
cd /ppbl2023-plutus-template
git pull
```
If you do not have an `/output` directory, be sure to make one:
```bash
mkdir output
```

<br />
---

## Step 2: Choose your development environment and run the repl

### Option 1: Local Environment
- Follow the guide in [Lesson 101.4](/modules/101/1014) to run `nix-shell` in `/plutus-apps`. We are still using `v1.1.0` of [Plutus Apps](https://github.com/input-output-hk/plutus-apps)
- In `nix-shell`, navigate to `/ppbl2023-plutus-template`
- Run `cabal repl`

### Option 2: Demeter.run
- Follow the guide in [Lesson 101.3](/modules/101/1013) to open the PPBL Plutus Template in [Demeter.run](https://demeter.run/)
<br />
---


## Step 3: Compile the Plutus minting script

When you successfully enter `cabal repl`, you should see a prompt like this:
```bash
AlwaysSucceeds.Compiler>
```

We do not want to use the AlwaysSucceeds Compiler. We'd like to use the Tokens Compiler. Here is how to load it:

```bash
AlwaysSucceeds.Compiler> :l Tokens.Compiler
```

Now you will see this prompt:
```bash
Tokens.Compiler>
```

And you can run `writePlutusMintingScript`


```bash
Tokens.Compiler> writePlutusMintingScript
Right()
```
You'll know the Plutus script is successfully compiled if you see `Right()`.

**Congratulations, you just created a minting policy script with Plutus!**

<br />
---

## Step 4: Code Review
Now that you know the process, let's Take a look at the contents of `/src/Tokens/Minter.hs` and `/src/Tokens/Compiler.hs`

The validation logic looks like this:
```haskell
{-# INLINABLE mkPolicy #-}
mkPolicy :: Integer -> ScriptContext -> Bool
mkPolicy _redeemer _ctx = _redeemer == 1618033988
```

This is a Minting Validator with one rule. At minting time, the "Redeemer" must be equal to `1618033988`. In Step 6 below, you will see how to include a Redeemer value in a minting transaction.

In `Tokens.Compiler`, the `writePlutusMintingScript` function looks like this:
```haskell
writePlutusMintingScript :: IO (Either (FileError ()) ())
writePlutusMintingScript = writeValidator "output/mint.plutus" Minter.validator
```

You can change the name of the output file from `mint.plutus` to whatever you'd like.

<br />
---

## Step 5: Exit the `repl` and exit `nix-shell`
- Note: `CTRL + D` is the keyboard shortcut for exiting both.


<br />
---

## Step 6: Build, sign, and submit a minting transaction
In `/ppbl2023-plutus-template/bash-scripts`, find the file `mint-tokens-plutus-script.sh`. It is very similar to the `mint-tokens-native-script.sh` shell script that was introduced in [Lesson 202.2](/modules/202/2022).

Note the differences in `cardano-cli transaction build`:
```bash
 cardano-cli transaction build \
--babbage-era \
--testnet-magic 1 \
--tx-in $TX_IN \
--tx-in-collateral $TX_IN \
--tx-out $RECEIVER+"1500000 + $QUANTITY $POLICY_ID.$TOKEN_HEX" \
--mint "$QUANTITY $POLICY_ID.$TOKEN_HEX" \
--mint-script-file $MINT_SCRIPT_FILE_PATH \
--mint-redeemer-value $SECRET_NUMBER \
--change-address $ADDRESS \
--protocol-params-file protocol.json \
--out-file mint-native-assets-with-plutus.draft
```

Compare this script to `mint-tokens-native-script.sh`
- Anyone can mint a token with this script - it does require any particular Pubkeyhash
- The minting transaction requires collateral and redeemer
- In the video, we don't cover all the differences: only what is new here. Then you can try the script on your own!

<br />
---

## Think About It:
- Now, anyone mint a token with Policy ID: `b4dff8a4bf58ef312cfc498231d4385349cdf9bc39e3bd0278f7637e`. In [Mastery Assignment 202](/modules/202/assignment2021), you can demonstrate mastery of SLT 202.4 by sending some tokens with this Policy ID to your browser wallet.
- Is this method of assessment truly secure?
- What is one simple thing you could do to change `Tokens.Minter` so that the result is a different Policy ID?

import MDXLessonLayout from "@/src/components/lms/Lesson/MDXLessonLayout.tsx";
export default ({ children }) => <MDXLessonLayout>{children}</MDXLessonLayout>;
